//
//  fbc.h
//  Algorithm: FBC128_256
//
//  Created by administrator on 2019/10/15.
//  Copyright © 2019 X. Feng. All rights reserved.
//

#ifndef fbc_h
#define fbc_h

int Key_Schedule(unsigned char* seedkey, int keylen, int direction, unsigned char* subkey);

int Crypt_Enc_Block(unsigned char* input, int in_len, unsigned char* output, int* out_len, unsigned char* key, int keylen);
int Crypt_Dec_Block(unsigned char* input, int in_len, unsigned char* output, int* out_len, unsigned char* key, int keylen);

int Crypt_Enc_Block_CBC(unsigned char* input, int in_len, unsigned char* output, int* out_len, unsigned char* key, int keylen);
int Crypt_Dec_Block_CBC(unsigned char* input, int in_len, unsigned char* output, int* out_len, unsigned char* key, int keylen);

int Crypt_Enc_Block_Round(unsigned char* input, int in_len, unsigned char* output, int* out_len, unsigned char* key, int keylen, int cryptround);

#endif /* fbc_h */
